%global gem_name ffi
%global libname %{gem_name}_c.so

%global gem_dir      %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global gem_instdir  %{gem_dir}/gems/%{gem_name}-%{version}
%global gem_libdir   %{gem_instdir}/lib
%global gem_cache    %{gem_dir}/cache/%{gem_name}-%{version}.gem
%global gem_spec     %{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
%global gem_docdir   %{gem_dir}/doc/%{gem_name}-%{version}
%global ruby_archdir %(ruby -rrbconfig -e 'puts Config::CONFIG["sitearchdir"] ')

Name:           rubygem-%{gem_name}
Version:        1.0.9
Release:        11%{?dist}
Summary:        FFI Extensions for Ruby
Group:          Development/Languages

License:        LGPLv3
URL:            http://wiki.github.com/%{gem_name}/%{gem_name}
Source0:        https://github.com/%{gem_name}/%{gem_name}/archive/%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  ruby
BuildRequires:  ruby-devel
BuildRequires:  rubygems
BuildRequires:  rubygem(rake)
BuildRequires:  rubygem(rake-compiler)
BuildRequires:  libffi-devel
#BuildRequires:  rubygem(rspec-core)
BuildRequires:  pkgconfig
Requires:       libffi
Requires:       ruby(rubygems)
Requires:       ruby(abi) >= 1.8
Provides:       rubygem(%{gem_name}) = %{version}

%description
Ruby-FFI is a ruby extension for programmatically loading dynamic
libraries, binding functions within them, and calling those functions
from Ruby code. Moreover, a Ruby-FFI extension works without changes
on Ruby and JRuby. Discover why should you write your next extension
using Ruby-FFI here[http://wiki.github.com/ffi/ffi/why-use-ffi].

%prep
%setup -q -n %{gem_name}-%{version}

%build
export CFLAGS="%{optflags}"
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
rake gem
gem install -V -d --local --no-ri -i ./geminst --force pkg/%{gem_name}-%{version}.gem

%install
rm -rf %{buildroot}
mkdir %{buildroot}
install -d -m0755 %{buildroot}%{gem_dir}
install -d -m0755  %{buildroot}%{ruby_archdir}
cp -R %{_builddir}/%{gem_name}-%{version}/geminst/* %{buildroot}%{gem_dir}
mv %{buildroot}%{gem_libdir}/%{libname} %{buildroot}%{ruby_archdir}
rm -rf %{buildroot}%{gem_instdir}/ext

%check
# https://github.com/ffi/ffi/issues/189
#sed -i -e 's| -mimpure-text||' libtest/GNUmakefile
#rake -v test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc %{gem_instdir}/README.rdoc
%doc %{gem_instdir}/History.txt
%doc %{gem_instdir}/LICENSE
%doc %{gem_docdir}
%dir %{gem_instdir}
# This file does not exist in 15
%if 0%{?fedora} <= 14
    %{gem_instdir}/.require_paths
%endif
%{gem_instdir}/Rakefile
%{gem_instdir}/gen
%{gem_libdir}
%{gem_instdir}/spec
%{gem_instdir}/tasks
%{ruby_archdir}/%{libname}
%{gem_cache}
%{gem_spec}


%changelog
* Mon Apr 07 2014 Melissa Stone <melissa@puppetlabs.com> - 1.0.9-11
- (CPR-26) install ffi_c.so into correct libdir so gem can be used

* Thu Jun 27 2013 Michael Stahnke <stahnma@puppetlabs.com> - 1.0.9-10
- Rebuilding due to ruby rebuild

* Tue Apr 09 2013 Matthaus Owens <matthaus@puppetlabs.com> - 1.0.9-9
- Rebuilt for Puppet Labs dependencies repos. Bump release to eclipse epel :)

* Tue Feb 26 2013 Matthaus Owens <matthaus@puppetlabs.com> - 1.0.9-6
- Rebuilt for Puppet Labs dependencies repos. Updated to build for el5,el6,f16,f17,f18

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.9-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Feb 02 2012 Vít Ondruch <vondruch@redhat.com> - 1.0.9-4
- Rebuilt for Ruby 1.9.3.

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.9-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Jun 14 2011 Bryan Kearney <bkearney@redhat.com> - 1.0.9-2
- Fixed the License, it is actually LGPL

* Mon Jun 13 2011 Bryan Kearney <bkearney@redhat.com> - 1.0.9-1
- Bring in 1.0.9 from upstream.

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Mar 10 2010 Bryan Kearney <bkearney@redhat.com> - 0.6.2-1
- Power PC fixes from upstream which were found testing 0.6.2

* Tue Feb 22 2010 Bryan Kearney <bkearney@redhat.com> - 0.6.2-1
- Pull in 0.6.2 from upstream

* Tue Feb 22 2010 Bryan Kearney <bkearney@redhat.com> - 0.5.4-3
- Final updates based on package review

* Tue Feb 16 2010 Bryan Kearney <bkearney@redhat.com> - 0.5.4-2
- Updates Based on code review comments

* Mon Feb 15 2010 Bryan Kearney <bkearney@redhat.com> - 0.5.4-1
- Initial specfile
